Subject: bug#35353: 26.2; Buffer *xref*: (1) hard-coded mouse-1, (2) major mode name

From: Drew Adams <[email-masked]>
Date: Mon, 22 Apr 2019 06:23:23 -0700 (PDT)

> > > FWIW, I see no important reasons to set point in XREF buffers by
> > > clicking the mouse.
> >
> > It's always important to be able to set point by
> > clicking the mouse.
> 
> I disagree.  And it's easy to disagree, because you didn't provide any
> rationale, none at all.

Of course I did - more than one, and more than once now.
Click a mouse button to set point, select a window, and
focus its frame.  Is that not enough rationale for you?

I find it really hard to believe that this is not
obvious to you.

Surely you used a mouse with Emacs before we
switched the default behavior to having mouse-1,
not mouse-2, follow links?  And surely you've
accidentally clicked mouse-1 on a link (e.g. in
Dired) when all you wanted to do was select the
window?

In any case, surely you do realize or can
imagine that at least some Emacs users set
`mouse-1-click-follows-link' to nil?  Surely
you can imagine that removing the effect of
that setting for *xref* buffers could be
upsetting and surprising to them, no?

> > Do you think that buffer *xref* is different in this
> > regard from Dired, compilation, or Occur buffers?
> > How so?  These are buffers that are dense with links,
> > making it important that users can use the mouse not
> > only to follow links but also to set point.
> 
> There are no links in the XREF buffer, not really.  This buffer is an
> aid to select on of several possible symbols, that's all.

Sigh.

The "non-links" have `mouse-face'. They have a `keymap'
property that binds `mouse-1' and `mouse-2' to commands
that follow the "non-link" to its location.  They have
`:help-echo' that says "mouse-2: display in another
window, RET or mouse-1: follow reference".  When you
click them or hit RET or C-o they sure seem to follow
the "non-links".  What am I missing?

Using `A' In Dired puts me in an *xref* buffer.  Using
the "non-links" in that buffer do NOT, in any way that
I can imagine you might mean, "select on[e] of possible
symbols".

I can follow these "non-links", but I'm really having
trouble following you.  And the problem (this bug) is
that I cannot NOT follow these "non-links".